;;DDSL commands
;
;   DDSL -  Sets the current layer by picking from a dialog box of
;           Layers that exist in the currnent file. No XREF layers
;           are displayed.

;
;   Written by :    Mark W. Kiker
;   Date:           2004
;
;   USE AT YOUR OWN RISK...
;
;
;     Permission to use, copy, modify, and distribute this software 
;     for any purpose and without fee is hereby granted, provided 
;     that the above copyright notice appears in all copies and that 
;     both that copyright notice and this permission notice appear in 
;     all supporting documentation.
;
;     THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED
;     WARRANTY.  ALL IMPLIED WARRANTIES OF FITNESS FOR ANY PARTICULAR
;     PURPOSE AND OF MERCHANTABILITY ARE HEREBY DISCLAIMED.
;     ****************************************************************

;;;
;;; Error Function
;;;
(defun *cng_err* (msg)
   (if (/= msg "Function cancelled")
      (if (= msg "quit / exit abort")   
         (princ)
         (princ (strcat "\nError: " msg))
      )
   )
   (setq *error* *err_old* *err_old* nil)
   (princ)
)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; DDSL sets layer by displaying a list of layers in a dialog box.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun c:DDSL ( / dcl_id lnlist lboxlist
      llist lname set_lay xref)
   (setq *err_old* *error* *error* *cng_err*)
   (setq dcl_id (load_dialog "DDSL.dcl"))
   (cond ((not (new_dialog "DDSL" dcl_id))
          (princ "Unable to load DDSL.DCL.")
          (exit))
   )
   (setq lnlist nil lboxlist nil)
   (setq llist (tblnext "layer" T))
   (while llist
      (setq lname (cdr (assoc 2 llist)))
      (if (wcmatch lname "*|*")
      (setq xref lname)
      (setq lnlist (append lnlist (list lname)))
      )
      (setq llist (tblnext "layer"))
   )
   (if lnlist (setq lnlist (acad_strlsort lnlist)))
   
   (action_tile "layerbox" "(setq set_lay (nth
      (atoi $value) lnlist))")
   (action_tile "cancel" "(exit)")
   
   (start_list "layerbox")
   (mapcar 'add_list lnlist)
   (end_list)

   (start_dialog)
   (unload_dialog dcl_id)
   (setvar "clayer" set_lay)
   
   (setq *error* *err_old* *err_old* nil)
   (princ)
)




;(prompt "DDSL Loaded.")
(princ)
